#!/bin/sh
#
# Dspam + MySQL setup.
#
#

DB_NAME="dspam"
DB_USER="dspam"
DB_PASS="dspam"

DSPAM_VERSION=""
DSPAM_CONF="/etc/dspam.conf"
DSPAM_HTTP_CONF="/etc/httpd/conf.d/httpd-dspam.conf"
DSPAM_WEB_ROOT="/home/httpd/sites/dspam"
MYSQL_CREATE="/usr/share/dspam-mysql/mysql_objects-speed.sql"
MYSQL_VIRTUAL_USERS="/usr/share/dspam-mysql/virtual_users.sql"
DOMAINNAME=`hostname -d`


### M Y S Q L ###
echo " MYSQL installation check"
  MYSQL_PASS=""
  id mysql >/dev/null 2>&1
  if [ $? -eq 0 ]; then
    if [ -d ~mysql ]; then
      MYSQL_PASS="-p`grep pass ~mysql/.my.cnf 2>/dev/null | awk -F\"=\" '{print $2}'`"
    else
      MYSQL_PASS="-p`grep ^pass /etc/my.cnf 2>/dev/null | sed -e 's/\s//g' | awk -F"=" '{print $2}'`"
    fi
  fi
  if [ "x${MYSQL_PASS}" = "x-p" ]; then
    MYSQL_PASS=""
  fi
#echo "===${MYSQL_PASS}"
  mysql -u root ${MYSQL_PASS} -e "SHOW DATABASES;" > /dev/null 2>&1
  if [ $? -eq 0 ]; then
    echo " MySQL server found and ready [ OK ]"
    MYSQL_IP="localhost"
  else
    echo " MySQL server or client not found or not ready."
    exit 1
 fi


echo " MySQL server IP [${DB_HOST}]"
echo -n "   Enter MySQL database name [${DB_NAME}]: "
read DB_NAME_TMP
if [ "x${DB_NAME_TMP}" != "x" ]; then
  DB_NAME=${DB_NAME_TMP}
fi

mysql -u root ${MYSQL_PASS} -e "USE ${DB_NAME};" > /dev/null 2>&1
if [ $? -eq 0 ]; then
  echo "ERROR: Database ${DB_NAME} already exists"
  exit 1
fi

echo -n "   Enter MySQL user name [${DB_USER}]: "
read DB_USER_TMP
if [ "x${DB_USER_TMP}" != "x" ]; then
  DB_USER=${DB_USER_TMP}
fi

echo -n "   Enter \"${DB_USER}\" password [${DB_PASS}]: "
read DB_PASS_TMP
echo ""
if [ "x${DB_PASS_TMP}" != "x" ]; then
  DB_PASS=${DB_PASS_TMP}
fi

echo " MySQL configuration"
  mysql -u root ${MYSQL_PASS} -e "CREATE DATABASE ${DB_NAME};" || exit 1
  mysql -u root ${MYSQL_PASS} -e "grant INSERT,SELECT,UPDATE,DELETE on ${DB_NAME}.* to ${DB_USER}@localhost identified by '${DB_PASS}';" || exit 1
  mysql -u root ${MYSQL_PASS} -e "grant INSERT,SELECT,UPDATE,DELETE on ${DB_NAME}.* to ${DB_USER}@'%' identified by '${DB_PASS}';" || exit 1
  mysql -D ${DB_NAME} -u root ${MYSQL_PASS} < ${MYSQL_CREATE} || exit 1
  mysql -D ${DB_NAME} -u root ${MYSQL_PASS} < $MYSQL_VIRTUAL_USERS || exit 1
#  rm -f ${MYSQL_CREATE} || exit 1
  echo " MySQL configuration [ OK ]"


if [ -f ${DSPAM_CONF} ]; then
    echo " DSPAM configuration"
    cp -p ${DSPAM_CONF} ${DSPAM_CONF}.bkp
    echo -n "   PROCESS on ${DSPAM_CONF} ... "
    sed "s/^MySQLUser.*/MySQLUser               ${DB_NAME}/" ${DSPAM_CONF} | \
    sed "s/^MySQLPass.*/MySQLPass               ${DB_PASS}/" > ${DSPAM_CONF}.tmp || exit 1
    mv ${DSPAM_CONF}.tmp ${DSPAM_CONF} || exit 1
    chown root.mail ${DSPAM_CONF} #2>/dev/null
    chmod 644 ${DSPAM_CONF}
    echo "[ OK ]"
  else
    echo "ERROR: ${DSPAM_CONF} not found"
    exit 1
fi


## Uncomment conf files
if [ -f ${DSPAM_HTTP_CONF} ]; then
   echo "Uncommenting httpd-dspam.conf"
   sed -ie 's/^#//' ${DSPAM_HTTP_CONF}
else
   echo "ERROR: ${DSPAM_HTTP_CONF} not found"
   exit 1
fi


echo ""
echo " ###############################"
echo " ### Installation successful ###"
echo " ###############################"
echo
